import numpy as np
import torch
import torch.utils.data
import os
#import matplotlib.pyplot as plt
import torchvision
from PIL import Image
from torchvision import transforms
class med(torch.utils.data.Dataset):
    def __init__(self,img_dir,anno_dir,transform = None):
        # TODO
        # 1. Initialize file paths or a list of file names.
        img_ilist = []
        img_alist = []
        temp = []
        self.img_dir = img_dir
        self.anno_dir = anno_dir
        for subdir in os.listdir(img_dir):
            for file in os.listdir(os.path.join(img_dir,subdir)):
                img_ilist.append(os.path.join(img_dir,subdir,file))
                img_alist.append(os.path.join(anno_dir,subdir,file))
        self.img_ilist = img_ilist#[:100]
        self.img_alist = img_alist
        self.transform = transform

    def __getitem__(self, index):
        # TODO
        # 1. Read one data from file (e.g. using numpy.fromfile, PIL.Image.open).
        # 2. Preprocess the data (e.g. torchvision.Transform).
        # 3. Return a data pair (e.g. image and label).
        img_ilist = self.img_ilist
        img_alist = self.img_alist
        img_ipath = self.img_ilist[index]
        imgi = Image.open(img_ipath).convert('L')
        imgi = imgi.resize((240,240))
        #######################################
        ##  Do pic resize or others here     ##
        #imgi = np.load(img_ipath)
        #print(img_ipath)
        #print(imgi.shape)
        #print(imgi)
        #npy = np.zeros((240,240,1))
        #npy[:,:,0] = imgi
        #print(npy.shape)
        #######################################

        img_apath = self.img_alist[index]
        imga = Image.open(img_apath)
        imgaa = Image.open(img_apath).convert('L')
        imga = imga.resize((240,240))
        #######################################
        ##  Do pic resize or others here     ##
        #imga = np.load(img_apath)
        #print(imga)
        #print(imga.size)
        #######################################

        if self.transform is not None:
            imgi = self.transform(imgi)
            imga = self.transform(imga)
            imgaa = self.transform(imgaa)

            imagei = imgi#.type(torch.FloatTensor)
            imagea = imga#.type(torch.FloatTensor)
            imageaa = imgaa

        return imagei,imagea,imageaa

    def __len__(self):
        # You should change 0 to the total size of your dataset.
        return len(self.img_ilist)
'''
trans = transforms.ToTensor()
batch_size = 1
custom_dataset = med('./Dataset/BRATS_PRE/N_BRATS_HALF1',
                    './BRATS_PRE/N_BRATS_HALF1_ANNO',
                    transform = trans)
train_dataset = torch.utils.data.DataLoader(dataset=custom_dataset,
                                            batch_size = batch_size,
                                            shuffle = True)
for i, (imagei,imagea) in enumerate(train_dataset):
    if i<=3:
        print(imagei)
        print(imagea)
        img_i = imagei[0,0,:,:]
        img_a = imagea[0,0,:,:]
        print(img_i.shape)
        print(img_i[150:170,150:170])
        #print(npamg[200:210,200:210])
'''
